/
/	to do
/      =======
/
/
/	virtual blocks
/
/	more than 32767 blocks on tape.
/
/	phserr recovery.
/	phsedes:
/
/	links
/
/	re-work gettape for efficiency
/	
/	whole directory extract.
/
/	possible use of pattern matching for extract
/

/	length of tape - only dump if will all fit.
/	maxblka - implement must allow for directory size.
/
/
/
/
/
/
/
/
/
/
/
/
/
/
/
//////////////////////////////////////////////////////////////////////////
//									//
//	this is a version of 'tp' modified by ian j. AGSM		//
//									//
//	enhancements or otherwise:					//
//									//
//	1) new command 's'. this is a selective dump facility.		//
//	   the number following 's' in the key is taken as a number	//
//	   of hours -- if number absent then /etc/last-dump-time	//
//	   contains time last dump  -- any file modified within/since	//
//	   that time will be dumped.					//
//									//
//	2)  new commands  implemented, new meanings, old		//
//	    unused commands are out. see 'swtab' below			//
//									//
//	3)  tape blocksize increased to tbloksiz bytes, this allows 	//
//	    more data to be kept on tape than is possible using		//
//	    a blocksize of 512. bytes.					//
//									//
//////////////////////////////////////////////////////////////////////////


.globl	_localtime,_ctime

tbloksiz = 32768.		/ blocksize on tape - must be a integer power of 2
tbloking = tbloksiz\/512.	/ sectors per tape block.
nrzreclen = [tbloksiz+534.+799.]\/800.		/ record length in inches (800bpi)
pereclen  = [tbloksiz+1067.+1599.]\/1600.	/ record length in inches (1600bpi)

smdate = 30.
mknod  = 14.

//////////////////////////////////////////////////////////////////////////

	sys	time
	mov	r0,dumptime
	mov	r1,dumptime+2		/ note program start time
	mov	(sp),rnarg
	mov	(sp)+,narg
	mov	$cmexit,command
	tst	(sp)+
	cmp	narg,$2
	bge	1f
	mov	$2,narg
	br	3f
1:
	mov	(sp)+,r0
	mov	sp,parg
1:
	movb	(r0)+,r1
	beq	3f
	mov	$swtab,r2
2:
	cmp	r1,(r2)+
	beq	2f
	tst	(r2)+
	bne	2b
	br	useerr
2:
	jsr	pc,*(r2)+
	br	1b
3:
	jsr	pc,optap
	sys	creat; tmpdirname; 0600
	bes	8f
	sys	close
	sys	open; tmpdirname; 2
	bes	8f
	mov	r0,dirfd

	mov	tpsize,r0
	mul	$12.,r0			/ get inches on tape.
	div	recordln,r0		/ r0 = records that will fit on tape.
	mov	r0,maxblka		/ maximum block address on tape.

	jmp	*command
8:
	jsr	r5,mesg
		< directory file create error\n\0>; .even
	jbr	done

optap:
	jsr	pc,rewind
	cmp	command,$cmn
	beq	2f
	sys	open; mt; 0
	br	3f
2:
	sys	open; mt; 1
3:
	bes	1f
	mov	r0,fio
	rts	pc
1:
	jsr	r5,mesg
		<Tape open error\n\0>; .even
	jbr	done

setcom:
	cmp	command,$cmexit
	bne	useerr
	mov	(r5)+,command
	rts	r5

noflag:
	mov	(r5)+,r0
	beq	1f
	tstb	(r0)
	beq	noflag
	br	useerr
1:
	rts	r5

useerr:
	jsr	r5,mesg
		<Bad usage\n\0>; .even
	jbr	done

swtab:
	'0; dcof	/ d r i v e    0
	'1; dcof	/ d r i v e    1
	'm; dcm		/ d e n s i t y   800 b.p.i.
	'h; dch		/ d e n s i t y   1600 b.p.i.
	'f; dcf		/ f e e t  - size of tape
/
	'x; dcx		/ e x t r a c t  named files.
	'n; dcn		/ n e w  dump tape to be created
	'l; dcl		/ l i s t   contents of dump tape 
/
	's; dcs		/ i n c r e m e n t a l l y  dump files to dump tape
	'c; dcc		/ c r e a t e   as needed directories/special-files (full extract only)
	'u; dcu		/ u p d a t e   last dump time in /etc/last-dump-time (new dump only)
/
	'v; dcv		/ v e r b o s e   dont be silent, give all info
	'q; dcq		/ q u e s t i o n   after each file selected for user approval(y-yes n-no x-exit)
	'i; dci		/ i g n o r e  tape read/write errors
	 0; 0

dcof:
	movb	r1,munit
	movb	r1,mtx
	rts	pc

dcm:
	movb	r1,mtype
	mov	$nrzreclen,recordln
	rts	pc

dch:
	movb	r1,mtype
	mov	$pereclen,recordln
	rts	pc

dcf:
	jsr	pc,argnum		/ see if tape length specified.
	bne	0f			/ --> yes so use it.
	mov	$3200.,r1		/ assume 3200 ft. tape.
0:
	mov	r1,tpsize		/ save length of tape.
	rts	pc

dci:
	incb	fli
	rts	pc

dcn:
	jsr	r5,setcom; cmn
	rts	pc

dcl:
	jsr	r5,setcom; cml
	rts	pc

dcu:
	incb 	flu			/ cause start time to be written to /etc/last-dump-time
	rts	pc

dcv:
	incb	flv
	rts	pc

dcq:
	incb	flq
	rts	pc

dcx:
	jsr	r5,setcom; cmx
	rts	pc
dcc:
	cmp	$2,narg
	bne	useerr			/ only allow with full extract.
	inc	flc
	rts	pc

dcs:
	incb 	fls			/ use selective file dump
	jsr	pc,argnum		/ obtain number that optionally follows
	bne	4f			/ if non-zero then use hour interval specified
	mov	r0,-(sp)		/ save arg pointer
	sys	open; ldt; 0
	bec	3f
2:
	jsr	r5,mesg
		< last-dump-time unable to be opened\n\0>; .even
	jbr	done
3:
	mov	r0,r1
	sys	read; seltim; 4		/ dump all files modded after this time
	bes	2b
	cmp	$4,r0
	bne	2b
	mov	r1,r0
	sys	close
	mov	(sp)+,r0
	rts	pc
4:
	mov	r0,-(sp)
	mov	r1,r0
	mpy	$-3600.,r0		/ get seconds(-ve) not hours.
	add	dumptime+2,r1		/ subtract
	adc	r0			/  time
	add	dumptime,r0		/   specified.
	mov	r0,seltim
	mov	r1,seltim+2		/ all files modified after this time dumped
	mov	(sp)+,r0
	rts	pc

//////////////////////////////////////////////////////////////////////////

argnum:
	clr	r1
0:
	movb	(r0),r2			/ pick next char from 1st argument.
	sub	$'0,r2
	blt	1f			/ not a valid digit so branch
	cmp	$'9,r2
	blt	1f			/ not a valid digit so branch
	inc	r0
	mul	$10.,r1
	add	r2,r1			/ build no. of hours.
	br	0b
1:
	tst	r1		/ set cc to indicate whether number found
	rts	pc

//////////////////////////////////////////////////////////////////////////

cmexit:
	jsr	r5,mesg
		<no function specified\n\0>; .even
	jbr	done

//////////////////////////////////////////////////////////////////////////

cmn:
	jsr	r5,noflag; flc; 0
	jsr	pc,getfiles		/ determine those file to be dumped
	jsr	pc,make
	tst	flu
	jeq	usage		/ no update of last-dump-time reqd.
	sys	creat; ldt; 0600
	bec	2f
1:
	jsr	r5,mesg
		<can't update last-dump-time\n\0>; .even
	jbr	done
2:
	mov	r0,r1
	sys	write; dumptime; 4
	bes	1b
	cmp	r0,$4
	bne	1b
	br	usage

//////////////////////////////////////////////////////////////////////////

cml:
	jsr	r5,noflag; flc; flq; 0
	jsr	pc,rddir		/ read tape directory onto disk and format it
	jsr	r5,mesg
		<\n\n this dump initiated on   \0>; .even
	mov	dumptime+2,-(sp)
	mov	dumptime,-(sp)
	jsr	pc,_ctime
	mov	r0,r1
	jsr	pc,pstr
	tstb	flv
	beq	1f
	jsr	r5,mesg
	<\n    mode    uid gid tapa     size   date    time name\n\n\0>; .even
1:
	jsr	r5,gettape; taboc
	jbr	usage2

//////////////////////////////////////////////////////////////////////////

cmx:
	jsr	r5,noflag; 0
	tstb	flc
	beq	1f
	tstb	flq
	beq	1f
	jbr	useerr			/ don't allow directory create with questions
1:
	jsr	pc,rddir		/ read tape directory into core and format it
	jsr	pc,tread		/ get first tape block 
	jsr	r5,gettape; xtract
	br	done

//////////////////////////////////////////////////////////////////////////

usage:
	mov	nused,r0
	jsr	r5,numb; 4
	jsr	r5,mesg
		< tape blocks\n\0>; .even
usage2:
	mov	nfiles,r0	/ no of files picked up
	jsr	r5,numb; 4
	jsr	r5,mesg
		< files on tape\n\0>; .even

/////////////////////////////////////////////////////////////////////////

done:
	jsr	r5,mesg
		<END\n\0>; .even
/	sys	unlink; tmpdirname
	jsr	pc,rewind
	sys	exit

/////////////////////////////////////////////////////////////////////////

pstr:
	movb	(r1)+,r0
	beq	1f
	jsr	pc,putc
	br	pstr
1:
	rts	pc

/////////////////////////////////////////////////////////////////////////

mesg:
	movb	(r5)+,r0
	beq	1f
	jsr	pc,putc
	br	mesg
1:
	inc	r5
	bic	$1,r5
	rts	r5

/////////////////////////////////////////////////////////////////////////

putc:
	movb	r0,ch
	mov	$1,r0
	sys	write; ch; 1
	rts	pc

/////////////////////////////////////////////////////////////////////////

getc:
	clr	r0
	sys	read; ch; 1
	movb	ch,r0
	rts	pc

/////////////////////////////////////////////////////////////////////////

rddir:
	mov	dirfd,r0
	sys	seek; 0; 0		/ position at start of disk dir.
1:
	jsr	pc,tread		/ read next tape block.
	beq	2f			/ --> end of directory file.
	jsr	pc,dwrite		/ write to disk for later use.
	br	1b			/ continue.
2:
	mov	dirfd,r0
	sys	seek; 0; 0		/get tape header from disk directory
	mov	dirfd,r0
	sys	read; tapeheader; dirsiz
	rts	pc

/////////////////////////////////////////////////////////////////////////

wrdir:
	mov	dirfd,r0
	sys	seek; 0; 0		/ position at start of disk dir.
	mov	dirfd,r0
	sys	write; tapeheader; dirsiz
	mov	dirfd,r0
	sys	seek; 0; 0		/ position at start of disk dir.
1:
	jsr	pc,dread		/ read next directory block.
	beq	2f			/ --> end of directory file.
	jsr	pc,twrite		/ write to tape
	br	1b			/ continue.
2:
	mov	fio,r0
	sys	close			/ write a tape mark.
	sys	open; mt; 1		/ write a tape mark and continue.
	mov	r0,fio
	rts	pc

/////////////////////////////////////////////////////////////////////////

tread:
	mov	fio,r0
	sys	read; tapeb; tbloksiz
	bes	trderr
	tst	r0		/ set cc for eof test on return
	beq	0f
	cmp	r0,$tbloksiz
	bne	trderr
	tst	r0		/ set cc for eof test on return
0:
	rts	pc

trderr:
	jsr	r5,mesg
		<Tape read error\n\0>; .even
	tstb	fli
	jeq 	done		/ don't ignore the error, stop
	mov	$tapeb,r0
2:
	clr	(r0)+
	cmp	r0,$tapeb+tbloksiz
	blo	2b
	rts	pc

/////////////////////////////////////////////////////////////////////////

dread:
	mov	dirfd,r0
	sys	read; tapeb; tbloksiz
	bes	drderr
	bit	$dirsiz-1,r0
	bne	drderr
	tst	r0
	rts	pc

drderr:
0
	jsr	r5,mesg
		<Directory file read error\n\0>; .even
	jbr	done

eread:
	mov	dirfd,r0
	sys	read; cde; dirsiz
	bes	drderr
	bit	$!dirsiz,r0
	bne	drderr
	tst	r0
	rts	pc

/////////////////////////////////////////////////////////////////////////

twrite:
	inc	nused		/ keep track of number blocks written to tape
	mov	fio,r0
	sys	write; tapeb; tbloksiz
	bes	twrerr
	cmp	r0,$tbloksiz
	bne	twrerr
	rts	pc

twrerr:
	jsr	r5,mesg
		<Tape write error\n\0>; .even
	jbr	done

/////////////////////////////////////////////////////////////////////////

dwrite:
	mov	dirfd,r0
	sys	write; tapeb; tbloksiz
	bes	dwrerr
	cmp	r0,$tbloksiz
	bne	dwrerr
	rts	pc

dwrerr:
	jsr	r5,mesg
		<Directory file write error\n\0>; .even
	jbr	done

ewrite:
	mov	dirfd,r0
	sys	write; cde; dirsiz
	bes	dwrerr
	cmp	r0,$dirsiz
	bne	dwrerr
	rts	pc

/////////////////////////////////////////////////////////////////////////

verify:
	movb	(r5)+,0f
	inc	r5
	tstb	flq
	bne	1f
	tstb	flv
	beq	2f
1:
	jsr	pc,9f
.data
9:
	jsr	r5,mesg
		0:<x \0>; .even
	rts	pc
.text
	mov	r1,-(sp)
	mov	$cpathname,r1
	jsr	pc,pstr
	mov	(sp)+,r1
	tstb	flq
	beq	1f
	jsr	r5,mesg
		< \0>
	jsr	pc,getc
	cmp	r0,$'x
	bne	3f
	jsr	pc,getc
	jbr	done
3:
	cmp	r0,$'\n
	beq	3f
	cmp	r0,$'y
	bne	4f
	jsr	pc,getc
	cmp	r0,$'\n
	beq	2f
4:
	jsr	pc,getc
	cmp	r0,$'\n
	bne	4b
	br	1b
1:
	jsr	r5,mesg
		<\n\0>
2:
	tst	(r5)+
3:
	rts	r5

/////////////////////////////////////////////////////////////////////////

getfiles:
	mov	dirfd,r0
	sys	seek; dirsiz; 0		/ start at first dir-entry on disk
	cmp	narg,$2
	bne	1f
	mov	$".\0,cpathname
	jsr	pc,callout
1:
	cmp	narg,$2
	ble	1f
	dec	narg
	mov	*parg,r1
	add	$2,parg
	mov	$cpathname,r2
2:
	movb	(r1)+,(r2)+
	bne	2b
	jsr	pc,callout
	br	1b
1:
	rts	pc

/////////////////////////////////////////////////////////////////////////

expand:
	sys	open; cpathname; 0
	bes	fserr
	mov	r0,-(sp)
1:
	mov	(sp),r0
	sys	read; catlb; 16.
	bes	fserr
	tst	r0
	beq	1f
	tst	catlb
	beq	1b
	mov	$cpathname,r0
	mov	$catlb+2,r1
	cmpb	(r1),$'.
	beq	1b
2:
	tstb	(r0)+
	bne	2b
	dec	r0
	mov	r0,-(sp)
	cmpb	-1(r0),$'/
	beq	2f
	movb	$'/,(r0)+
2:
	movb	(r1)+,(r0)+
	bne	2b
	jsr	pc,callout
	clrb	*(sp)+
	br	1b
1:
	mov	(sp)+,r0
	sys	close
	rts	pc

/////////////////////////////////////////////////////////////////////////

fserr:
	mov	$cpathname,r1
	jsr	pc,pstr
	jsr	r5,mesg
		< -- Cannot open file\n\0>; .even
	jbr	done

/////////////////////////////////////////////////////////////////////////

callout:
	sys	stat; cpathname; statb
	bes	fserr
	tstb	fls		/ selective file dump ??
	beq	0f		/ --> no.
	cmp	seltim,statb+32.
	blo	0f		/ will dump
	bhi	1f		/ dont dump
	cmp	seltim+2,statb+34.
	bhis	1f		/ dont dump
0:
	jsr	r5,verify; 'a
1:		rts pc
	inc	nfiles
	clr	csize
	clr	csize+2
	mov	statb+4,r0
	mov	r0,cmode
	movb	statb+7,cuid
	movb	statb+8,cgid
	mov	statb+32.,ctime
	mov	statb+34.,ctime+2
	mov	tapad,ctapea	/ store tape address in tape dir entry
	bic	$!60000,r0
	bne	1f		/ --> not a plain file
	movb	statb+9.,csize	/ only 24 bits for the moment
	mov	csize,r2
	mov	statb+10.,r3
	mov	r3,csize+2
	add	$511.,r3
	adc	r2
	ashc	$-9,r2		/ file size (next highest multiple of 512 bytes)
	add	r3,tapad	/ increment by size of file - ready for next file
	jsr	pc,ewrite	/ add to disk dir file
	rts	pc
1:
	cmp	r0,$40000
	jeq	2f		/ directory so see whats in it
	mov	statb+12.,cmajmin	/ identify the special file
	jsr	pc,ewrite	/ add to disk dir file
	rts	pc
2:
	jsr	pc,ewrite	/ add to disk dir file
	jbr	expand


/////////////////////////////////////////////////////////////////////////

gettape:
	mov	nfiles,r4		/ number of files on the tape.
	beq	5f			/ --> empty tape.
	mov	dirfd,r0
	sys	seek; dirsiz; 0		/ start at first dir-entry on disk
	clr	-(sp)
1:
	jsr	pc,eread	/ read next directory entry.
	beq	5f		/ --> none left.
	cmp	rnarg,$2
	ble	4f
	mov	$cpathname,r2
	mov	*parg,r3
3:
	tstb	(r3)
	beq	3f
	cmpb	(r2)+,(r3)+
	beq	3b
	br	2f
3:
	tstb	(r2)
	beq	4f
	cmpb	(r2),$'/
	bne	2f
4:
	mov	r5,-(sp)
	jsr	pc,*(r5)		/ call named routine to do the work
	mov	(sp)+,r5
	inc	(sp)
2:
	sob	r4,1b
5:
	tst	(sp)+
	bne	2f
	cmp	rnarg,$2
	ble	2f
	mov	*parg,r1
	jsr	pc,pstr
	jsr	r5,mesg
		< not found\n\0>; .even
2:
	dec	narg
	add	$2,parg
	cmp	narg,$2
	bgt	gettape
	tst	(r5)+
	rts	r5

/////////////////////////////////////////////////////////////////////////

numb:
	mov	r1,-(sp)
	mov	r0,-(sp)
	clr	r0
	br	1f

numbx:
	mov	r1,-(sp)
	mov	r0,-(sp)
	mov	csize,r0
1:
	mov	$catlb,r2
1:
	mov	$"  ,(r2)+
	cmp	r2,$catlb+12.
	blo	1b
	cmp	(r5),$2
	bne	1f
	mov	$"00,-2(r2)
1:
	mov	(sp)+,r1
	jsr	pc,numb2
	mov	(r5)+,r0
	sub	r0,r2
	mov	r2,0f
	mov	r0,0f+2
	mov	$1,r0
	sys	0; 9f
.data
9:
	sys	write; 0:..; ..
.text
	mov	(sp)+,r1
	rts	r5

numb1:
	clr	r0
numb2:
	div	$10.,r0
	mov	r1,-(sp)
	mov	r0,r1
	beq	1f
	jsr	pc,numb1
1:
	mov	(sp)+,r0
	add	$'0,r0
	movb	r0,(r2)+
	rts	pc

/////////////////////////////////////////////////////////////////////////

make:
	jsr	pc,wrdir

make1:
	mov	dirfd,r0
	sys	seek; dirsiz; 0	/ start at first dir entry.
1:
	jsr	pc,eread	/ read next entry.
	beq	1f		/ --> end of directory
	bit	$60000,cmode
	bne	2f		/ --> not a plain file.
	tst	csize
	bne	9f
	tst	csize+2
	beq	2f
9:
	mov	csize,r2
	mov	csize+2,r3
	add	$511.,r3
	adc	r2
	ashc	$-9,r2		/ file size (next highest multiple of 512 bytes)
	sys	open; cpathname; 0	/ open it for reading.
	bes	phserro
	mov	r0,r2		/ save file descriptor for reads
6:
	mov	r2,r0
	jsr	pc,0f
.data
0:
	sys	read;  7: tapeb  ;  8:  tbloksiz
	rts	pc
.text
	bes	phserrr
	add	r0,7b		/ point next available location in tape buffer
	cmp	$tapeb+tbloksiz,7b	/ file finished ??
	bhi	5f		/ --> yes.
	jsr	pc,twrite
	mov	8b,r0		/ bytes to be read last read.
	ash	$-9,r0		/ get as block count
	mov	$tapeb,7b	/ re-init
	mov	$tbloksiz,8b	/ re-init
	sub	r0,r3		/ adjust file size counter
	bne	6b		/ --> more to read.
	br	4f
5:
	mov	r0,r5		/ save length
	add	$511.,r0
	ash	$-9,r0		/ blocks just read
	sub	r0,r3		/ adjust file size
	bne	phserrs		/ should be zero
	cmpb	r5,csize+2	/ check that file same length now
	bne	phserrs
	sub	$tapeb,7b	/ make relative
	add	$511.,7b
	bic	$511.,7b	/ round up next read start address.
	add	$tapeb,7b	/ make absolute.
	mov	$tapeb+tbloksiz,8b
	sub	7b,8b		/ max length next record
	cmp	7b,$tapeb+tbloksiz	/ any room left ??
	bne	4f		/ --> yes, so continue
	jsr	pc,twrite
	mov	$tapeb,7b	/ re-init
	mov	$tbloksiz,8b	/ re-init
4:
	mov	r2,r0
	sys	close
2:
	br	1b		/ next file
1:
	cmp	7b,$tapeb
	beq	0f		/ only write last block if have to
	jsr	pc,twrite
	mov	$tapeb,7b	/ re-init
	mov	$tbloksiz,8b	/ re-init
0:
	rts	pc

/////////////////////////////////////////////////////////////////////////

phserro:	movb	$'O,phsedes;	br	phserr
phserrs:	movb	$'S,phsedes;	br	phserr
phserrr:	movb	$'R,phsedes;	br	phserr
phserr:
	mov	r1,-(sp)
	mov	$cpathname,r1
	jsr	pc,pstr
	jsr	r5,mesg
		< -- Phase error >
phsedes:	< \n\0>; .even
	mov	(sp)+,r1
	clr	ctime / time
	beq	2b
	sys	close
	br	2b

/////////////////////////////////////////////////////////////////////////

/	called from 'gettape' to list a directory entry.

taboc:
	tstb	flv
	jeq	4f
	mov	cmode,r0
	mov	r0,-(sp)
	movb	$'-,r5
	mov	$tabpf,mss
	bic	$!60000,r0	/ look at file type bits
	beq	0f		/ --> plain file
	movb	$'d,r5
	mov	$tabdf,mss
	cmp	$40000,r0
	beq	0f		/ --> directory
	movb	$'c,r5
	mov	$tabsf,mss
	cmp	$20000,r0
	beq	0f		/ --> character special
	movb	$'b,r5		/     block special
0:	mov	r5,r0
	jsr	pc,putc
	mov	(sp),r0
	ash	$-6,r0
	bit	$40,r0
	jsr	pc,pmod		/ print access bits for owner
	mov	(sp),r0
	ash	$-3,r0
	bit	$200,r0
	jsr	pc,pmod		/ print access bits for group
	mov	(sp)+,r0
	bit	$1000,r0
	jsr	pc,pmod		/ print access bits for others
	clr	r0
	bisb	cuid,r0
	jsr	r5,numb; 4	/ user id.
	clr	r0
	bisb	cgid,r0	/ group id
	jsr	r5,numb; 4
	mov	ctapea,r0	/ tape address
	jsr	r5,numb; 5
	jmp	*mss			/ jump on file type
tabpf:	mov	csize+2,r0	/ file size
	jsr	r5,numbx; 10.	/ 32-bit number
	br 	0f
tabdf:	jsr	r5,mesg
		<          \0>; .even
	br	0f
tabsf:	movb	cmajmin,r0
	jsr	r5,numb; 6
	movb	$',,r0
	jsr	pc,putc
	movb	cmajmin+1,r0
	jsr	r5,numb; 3
0:	mov	ctime+2,-(sp)
	mov	ctime,-(sp)
	jsr	pc,_localtime
	tst	(sp)+
	mov	r0,(sp)
	mov	6(r0),r0		/ day of the month(1-31)
	jsr	r5,numb; 3
	mov	$'/,r0
	jsr	pc,putc
	mov	(sp),r0
	mov	8.(r0),r0		/  month(0-11)
	inc	r0
	jsr	r5,numb; 2
	mov	$'/,r0
	jsr	pc,putc
	mov	(sp),r0
	mov	10.(r0),r0		/ year - 1900
	jsr	r5,numb; 2
	mov	(sp),r0
	mov	4(r0),r0		/ hours(0-23)
	jsr	r5,numb; 3
	mov	$':,r0
	jsr	pc,putc
	mov	(sp)+,r0
	mov	2(r0),r0		/ minutes(0-59)
	jsr	r5,numb; 2
	mov	$' ,r0
	jsr	pc,putc
4:
	mov	$cpathname,r1
	jsr	pc,pstr
	jsr	r5,mesg
		<\n\0>
	rts	pc

pmod:
	beq	1f
	mov	$'s,-(sp)
	br	2f
1:
	bit	$1,r0
	beq	1f
	mov	$'x,-(sp)
	br	2f
1:
	mov	$'-,-(sp)
2:
	bit	$2,r0
	beq	1f
	mov	$'w,-(sp)
	br	2f
1:
	mov	$'-,-(sp)
2:
	bit	$4,r0
	beq	1f
	mov	$'r,r0
	br	2f
1:
	mov	$'-,r0
2:
	jsr	pc,putc
	mov	(sp)+,r0
	jsr	pc,putc
	mov	(sp)+,r0
	jsr	pc,putc
	rts	pc

/////////////////////////////////////////////////////////////////////////

/	if the file exists delete it iff not a directory.
/	this is necessary otherwise a filesys mess will result

xunlnk:
	sys	stat; cpathname; statb	/ get info on the file.
	bes	0f			/ --> file don't exist
	bic	$!60000,statb+4		/ isolate file type bits
	cmp	$40000,statb+4		/ directory ??
	beq	0f
	sys	unlink; cpathname		/ remove it
0:
	rts	pc

/////////////////////////////////////////////////////////////////////////

/	called from 'gettape' to process a directory entry

xtract:
	tstb	flc		/ create directory mode ??
	beq	0f		/ --> no.
	mov	cmode,r0
	mov	r0,9f
	bic	$!60000,r0
	beq	0f		/ --> plain file
	clr	8f		/ assume directory.
	cmp	r0,$40000
	beq	4f		/ --> directory.
	mov	cmajmin,8f	/ special file.
4:
	jsr	pc,xunlnk
	jsr	r5,verify; 'c
		rts	pc
	bic	$!60777,9f
	sys	0; 7f
.data
7:
	sys	mknod; cpathname; 9: 0; 8: 0	/ create directory or special file
.text
	jes	crterr
	tst	8b
	bne	5f		/ --> special file( 0,0 will slip thru don't matter)
	mov	$cpathname,r0
	mov	$namewk,r1
	mov	$pathnaml\/2,r5
3:
	mov	(r0)+,(r1)+
	sob	r5,3b
	clr	r5
	mov	$cpathname,r0
8:
	cmpb	(r0),$'/
	bne	9f
	mov	r0,r5		/ save  the location of this slash -- it may be the last
9:
	tstb	(r0)+
	bne	8b		/ end of filename not yet encountered.
	movb	$'/,-1(r0)
	movb	$'.,(r0)+
	clrb	(r0)		/ 'name' is dot in directory just made
	sys	link; cpathname; namewk
	movb	$'.,(r0)+
	clrb	(r0)		/ 'name' is dotdot in current directory.
	mov	$dotname,8f	/ default prior file name
	sub	$cpathname,r5
	blt	9f		/ --> no slash in the name
	add	(r1),r5		/ modify it in the string area
	clrb	(r5)		/ 'name' is previous dir name
	mov	$cpathname,8f		/ set up pathname address in link
9:
	sys	0;9f
.data
9:
	sys	link; 8: 0; namewk
.text
	br	5f
0:
	bit	$60000,cmode
	bne	1f		/ --> not a plain file(ignore since flc=0)
	jsr	r5,verify; 'x
		rts pc
	mov	tapad,r5	/ current tape posn
4:
	mov	ctapea,r0	/ tape address of file
	cmp	r0,r5		/ how goes the position ??
	beq	0f		/ we are ther already.
	add	$tbloking,r5		/ address the start of
	bic	$tbloking-1,r5		/ the next tape block.
	cmp	r0,r5
	blo	0f		/ what we want is in this block
	jsr	pc,tread	/ get another block
	mov	r5,tapad	/ update current position.
	br	4b
0:
	jsr	pc,xunlnk
	mov	cmode,0f
	sys	0; 9f
.data
9:
	sys	creat; cpathname; 0:..
.text
	bes	crterr1		/ unable to create the file ??

	mov	r0,r2		/ save file descriptor
	mov	ctapea,r5	/ tape address of the file
2:
	bic	$![tbloking-1],r5		/ get block displacement in tape buffer
	ash	$9,r5		/ get as byte displacement
	mov	r5,9f
	add	$tapeb,9f	/ start writing from here.
	add	$-tbloksiz,r5
	neg	r5		/ bytes left in buffer
	mov	r5,8f
	sub	r5,csize+2
	sbc	csize	/ is this all the file ??
	bge	0f		/ --> no.
	add	csize+2,r5
	mov	r5,8f
	beq	2f		/ --> if null file/multiple of ....
	clr	r5
0:
	mov	r2,r0
	sys	0; 7f
.data
7:
	sys	write; 9: 0; 8: 0
.text
	bes	crterr1		/ write error
	cmp	r0,8b
	bne	crterr1		/ write error (out of space probably)
	tst	r5
	ble	2f		/ all done
	jsr	pc,tread
	add	$tbloking,tapad
	bic	$tbloking-1,tapad
	mov	tapad,r5
	br	2b		/ go again
2:
	mov	r2,r0
	sys	close
5:
	movb	cgid,0f+1
	movb	cuid,0f
	sys	0; 9f
.data
9:
	sys	chown; cpathname; 0:..
.text
	mov	ctime,r0
	mov	r1,-(sp)
	mov	ctime+2,r1
	sys	0; 9f
.data
9:
	sys	smdate; cpathname
.text
	mov	(sp)+,r1
1:
	rts	pc
dbgg:
	mov r2,-(sp);jsr r5,numb; 5;mov (sp)+,r2
	mov	$'\n,r0;jsr pc,putc
	rts	pc

crterr1:
	clr	r0
	mov	r1,-(sp)
	clr	r1
	sys	smdate; cpathname
	mov	(sp)+,r1
	mov	r2,r0
	sys	close

crterr:
	mov	$cpathname,r1
	jsr	pc,pstr
	jsr	r5,mesg
		< -- create error\n\0>; .even
	rts	pc


//////////////////////////////////////////////////////////////////////////

rewind:
	sys	open; magtape; 0
	sys	close
	rts	pc

//////////////////////////////////////////////////////////////////////////

.data
tapad:		0		/ first address in second file.
maxblka:	0		/ max number of blocks on tape
tpsize:		3200		/ number of feet on tape.
recordln:	pereclen		/ size of a single record in inches.
ldt:
		</etc/last-dump-time\0>
dotname:
		<.\0>
tmpdirname:
		<. master dir .\0>
magtape:
		</dev/rmt>
mtx:
		<1\0>
mt:
		</dev/rn>
mtype:
		<ht>
munit:		<0\0>
.even
.bss
tapeb: . = . +32768.
tapebend = .
dirfd: . = .+2
ch:	.=.+1
fli:	.=.+1
flu:	.=.+1
fls:	.=.+1
flc:	.=.+1
flv:	.=.+1
flq:	.=.+1
.even

seltim: .=.+4	/ all files modified after this time dumped
command:.=.+2
size:	.=.+2
nused:		.=.+2		/ no. of blocks used on tape
nfree:	.=.+2
catlb:	.=.+20.
narg:	.=.+2
rnarg:	.=.+2
parg:	.=.+2
fio:	.=.+2
mss:	.=.+2
statb:	.=.+40.

/	incore directory structure

cde:
cpathname:	.=.+50.		/ file pathname (null terminated)
cmode:		.=.+2.		/ file access bits
cuid:		.=.+1.		/ the owner
cgid :		.=.+1.		/ the owner
csize:		.=.+4.		/ file size (bytes)
cmajmin = 	csize+2		/ for special files is maj/min number
ctime:		.=.+4.		/ last modified time (secs since 1970)
ctapea:		.=.+2.		/ multiple by 512 to get byte address on tape of file

/	tape directory structure

tpathname = 0		/ file pathname (null terminated)
pathnaml = 50.		/ pathname max length. must be even length.
tmode = 50.		/ file access bits
tuid =52.		/ the owner
tgid = 53.		/ the owner
tsize = 54.		/ file size (bytes)
ttime = 58.		/ last modified time (secs since 1970)
ttapea = 62.		/ multiple by 512 to get byte address on tape of file
dirsiz = 64.		/ must be a power of 2 and a factor of 512.

/	tape header entry -- 1st 64 bytes on tape

tapeheader:
nfiles:		.=.+2		/ files dumped this tape
dumptime:	.=.+4		/ dump commenced at this time
		.=.+dirsiz
namewk:
	.=.+pathnaml
